/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { PolarLineSeriesBase } from "./PolarLineSeriesBase";
import { UnknownValuePlotting_$type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { runOn, enumGetBox, markType, markDep } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { PolarLineSeriesBaseView } from "./PolarLineSeriesBaseView";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
export let PolarLineSeries = /*@__PURE__*/ (() => {
    class PolarLineSeries extends PolarLineSeriesBase {
        constructor() {
            super();
            this.ab = PolarLineSeries.$;
        }
        get_d4() {
            return true;
        }
        by() {
            return new PolarLineSeriesView(this);
        }
        l4(a) {
            super.l4(a);
            this.vo = a;
        }
        vm(a) {
            let b = a;
            b.c5();
        }
        vn(a, b) {
            let c = b;
            c.c6(a.m, this.fx);
            this.se.az(this, this.s1(), runOn(this, this.rr));
            let d = false;
            let e = this.se.b;
            if (e != null) {
                d = true;
            }
            if (d) {
                this.t9(-1, this.sn.count, b.q);
            }
            this.se.ad(b.c8, true, false, true, false);
        }
        ve() {
            return this.vp;
        }
        l9(a, b, c, d) {
            super.l9(a, b, c, d);
            switch (b) {
                case PolarLineSeries.$$p[0]:
                    this.mn(false);
                    this.lu();
                    break;
            }
        }
    }
    PolarLineSeries.$t = markType(PolarLineSeries, 'PolarLineSeries', PolarLineSeriesBase.$);
    PolarLineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, PolarLineSeries, 'raisePropertyChanged', ['UnknownValuePlotting:vp:vr', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return PolarLineSeries;
})();
/**
 * @hidden
 */
export let PolarLineSeriesView = /*@__PURE__*/ (() => {
    class PolarLineSeriesView extends PolarLineSeriesBaseView {
        constructor(a) {
            super(a);
            this.c4 = null;
            this.c8 = new Path();
            this.c7 = new Path();
            this.c4 = a;
        }
        as() {
            super.as();
            if (!this.q) {
                this.b1.ql = Defaults.e;
            }
        }
        c5() {
            this.c8.an = null;
            this.c7.an = null;
            this.aq();
        }
        c6(a, b) {
            this.c4.vb.d(this.c8, a, b);
            this.aq();
        }
        bb() {
            super.bb();
        }
        bc() {
            super.bc();
            let a = this.bo();
            this.c7.an = this.c8.an;
            this.c7._stroke = a;
            this.c7.ad = this.e.fy + 3;
        }
        a6(a, b) {
            super.a6(a, b);
            if (a.d) {
                if (b) {
                    a.t(this.c7);
                }
                else {
                    a.t(this.c8);
                }
            }
        }
        al(a) {
            super.al(a);
            this.e.a9.exportPathData(a, this.c8, "polarShape", ["Main"]);
        }
    }
    PolarLineSeriesView.$t = markType(PolarLineSeriesView, 'PolarLineSeriesView', PolarLineSeriesBaseView.$);
    return PolarLineSeriesView;
})();
